pipeline {
    agent any
    environment {
        //be sure to replace "ncbao" with your own Docker Hub username
        DOCKER_IMAGE_NAME = "ncbao/train-schedule"
    }
    stages {
        stage('Build') {
            steps {
                echo 'Running build automation'
                sh './gradlew build --no-daemon'
                archiveArtifacts artifacts: 'dist/trainSchedule.zip'
            }
        }
        stage('Build Docker Image') {
            steps {
                script {
                    app = docker.build(DOCKER_IMAGE_NAME)
                    app.inside {
                        sh 'echo Hello, World!'
                    }
                }
            }
        }
        stage('Push Docker Image') {
            steps {
                script {
                    docker.withRegistry('https://registry.hub.docker.com', 'docker_hub_login') {
                        app.push("${env.BUILD_NUMBER}")
                        app.push("latest")
                    }
                }
            }
        }
        stage('Deploy Docker To Development') {
            steps {
                withCredentials([usernamePassword(credentialsId: 'kubernets_login', usernameVariable: 'USERNAME', passwordVariable: 'USERPASS')]) {
                    script {
                        try {
                            sh "sshpass -p '$USERPASS'  ssh -o StrictHostKeyChecking=no $USERNAME@$k8s_ip \"kubectl delete deployment train-schedule\""
                            sh "sshpass -p '$USERPASS'  ssh -o StrictHostKeyChecking=no $USERNAME@$k8s_ip \"kubectl delete service train-schedule\""
                        } catch (err) {
                            echo: 'caught error: $err'
                        }
                        sh "sshpass -p '$USERPASS'  ssh -o StrictHostKeyChecking=no $USERNAME@$k8s_ip \"kubectl create deployment train-schedule --image=${DOCKER_IMAGE_NAME}:${BUILD_NUMBER}\""
                        sh "sshpass -p '$USERPASS'  ssh -o StrictHostKeyChecking=no $USERNAME@$k8s_ip \"kubectl expose deployment train-schedule --port=8080 --target-port=8080\""
                    }
                }
            }
        }
    }
}